#include <Servo.h>          //standard library for the servo
#include <NewPing.h>        //for the Ultrasonic sensor function library.

//L298N motor control pins
const int LeftMotorForward = 7;
const int LeftMotorBackward = 6;
const int RightMotorForward = 4;
const int RightMotorBackward = 5;
const int Left2F = 9;
const int Left2B = 8;
const int Right2F = 10;
const int Right2B = 11;




const int EnA = 2; 
const int EnB = 3;
const int EnA2 = 12; 
const int EnB2 = 13;


//sensor pins
#define trig_pin A1 //analog input 1
#define echo_pin A2 //analog input 2

#define maximum_distance 200
boolean goesForward = false;
int distance = 100;

NewPing sonar(trig_pin, echo_pin, maximum_distance); //sensor function
Servo servo_motor; 

void setup(){
  pinMode (EnA, OUTPUT);
  pinMode (EnB, OUTPUT);
  pinMode (EnA2, OUTPUT);
  pinMode (EnB2, OUTPUT);
  pinMode(RightMotorForward, OUTPUT);
  pinMode(LeftMotorForward, OUTPUT);
  pinMode(LeftMotorBackward, OUTPUT);
  pinMode(RightMotorBackward, OUTPUT);
  pinMode(Left2F, OUTPUT);
  pinMode(Right2F, OUTPUT);
  pinMode(Left2B, OUTPUT);
  pinMode(Right2B, OUTPUT);

  
  servo_motor.attach(9); //our servo pin

  servo_motor.write(115);
  delay(200);
  distance = readPing();
  delay(100);
  distance = readPing();
  delay(100);
  distance = readPing();
  delay(100);
  distance = readPing();
  delay(100);
}

void loop(){

  int distanceRight = 0;
  int distanceLeft = 0;
  delay(50);

  if (distance <= 20){
    moveStop();
    delay(300);
    moveBackward();
    delay(400);
    moveStop();
    delay(300);
    distanceRight = lookRight();
    delay(300);
    distanceLeft = lookLeft();
    delay(300);

    if (distance >= distanceLeft){
      turnRight();
      moveStop();
    }
    else{
      turnLeft();
      moveStop();
    }
  }
  else{
    moveForward(); 
  }
    distance = readPing();
}

int lookRight(){  
  servo_motor.write(50);
  delay(500);
  int distance = readPing();
  delay(100);
  servo_motor.write(115);
  return distance;
}

int lookLeft(){
  servo_motor.write(170);
  delay(500);
  int distance = readPing();
  delay(100);
  servo_motor.write(115);
  return distance;
  delay(100);
}

int readPing(){
  delay(70);
  int cm = sonar.ping_cm();
  if (cm==0){
    cm=250;
  }
  return cm;
}

void moveStop(){
  
  digitalWrite(RightMotorForward, LOW);
  digitalWrite(LeftMotorForward, LOW);
  digitalWrite(RightMotorBackward, LOW);
  digitalWrite(LeftMotorBackward, LOW);
  digitalWrite(Right2F, LOW);
  digitalWrite(Right2B, LOW);
  digitalWrite(Left2F, LOW);
  digitalWrite(Left2B, LOW);



}

void moveForward(){

  if(!goesForward){

    goesForward=true;
    
    digitalWrite(LeftMotorForward, HIGH);
    analogWrite(EnA, 200);

    digitalWrite(RightMotorForward, HIGH);
    analogWrite(EnB, 200);

    digitalWrite(Left2F, HIGH);
    analogWrite(EnA2, 200);  
    
    digitalWrite(Right2F, HIGH);
    analogWrite(EnA2, 200);   

    

    digitalWrite(LeftMotorBackward, LOW);
    digitalWrite(RightMotorBackward, LOW); 
    digitalWrite(Right2B, LOW);
    digitalWrite(Left2B, LOW);
    
  }
}

void moveBackward(){

  goesForward=false;

  digitalWrite(LeftMotorBackward, HIGH);
  analogWrite(EnA, 200);

  digitalWrite(RightMotorBackward, HIGH);
  analogWrite(EnA, 200);
  digitalWrite(Left2B, HIGH);
  analogWrite(EnA2, 200);  
    
  digitalWrite(Right2B, HIGH);
  analogWrite(EnA2, 200);   

  
  digitalWrite(LeftMotorForward, LOW);
  digitalWrite(RightMotorForward, LOW);
  digitalWrite(Right2F, LOW);
    
  digitalWrite(Left2F, LOW);
}

void turnRight(){

  digitalWrite(LeftMotorForward, HIGH);
  analogWrite(EnA, 200);

  digitalWrite(RightMotorBackward, HIGH);
  analogWrite(EnB, 200);

  digitalWrite(Left2F, HIGH);
  analogWrite(EnA2, 200);  
    
  digitalWrite(Right2B, HIGH);
  analogWrite(EnA2, 200);   
  

  digitalWrite(LeftMotorBackward, LOW);
  digitalWrite(RightMotorForward, LOW);
  digitalWrite(Right2F, LOW);
  digitalWrite(Left2B, LOW);
  
  delay(500);
  
  digitalWrite(LeftMotorForward, HIGH);
  analogWrite(EnA, 200);

  digitalWrite(RightMotorForward, HIGH);
  analogWrite(EnB, 200);

  digitalWrite(LeftMotorBackward, LOW);
  digitalWrite(RightMotorBackward, LOW);
 
  
  
}

void turnLeft(){

  digitalWrite(LeftMotorBackward, HIGH);
  analogWrite(EnA, 200);

  digitalWrite(RightMotorForward, HIGH);
  analogWrite(EnB, 200);

  digitalWrite(Left2B, HIGH);
  analogWrite(EnA2, 200);  
    
  digitalWrite(Right2F, HIGH);
  analogWrite(EnA2, 200);   

  
  digitalWrite(LeftMotorForward, LOW);
  digitalWrite(RightMotorBackward, LOW);
  digitalWrite(Right2B, LOW);
  digitalWrite(Left2F, LOW);
  delay(500);
  
  digitalWrite(LeftMotorForward, HIGH);
  analogWrite(EnA, 200);

  digitalWrite(RightMotorForward, HIGH);
  analogWrite(EnB, 200);
  digitalWrite(LeftMotorBackward, LOW);
  digitalWrite(RightMotorBackward, LOW);
}
